#include "cc1000_b_mac.h"

static uint16_t val_med_init = 60;

#define NOISE_INIT_VALUE 	300
#define BUFFER_SIZE 		9

char static noise_Buffer[BUFFER_SIZE];
char static head;
//char static noise_level;
//char rssi_value;


char compare (const void *a, const void *b)
{
	return (*(int*)a - *(int*)b);
}

void update_noise_value (char value)
{
	/* noise_Buffer -> FIFO*/
	noise_Buffer[head] = value;
	head = (head+1) % BUFFER_SIZE;

	char tmp[BUFFER_SIZE];
	memcpy(tmp, noise_Buffer, sizeof(noise_Buffer));
	qsort(tmp, BUFFER_SIZE, sizeof(char), compare);
	/* BUFFER_SIZE equals 9, so we need the center position */
	char med = tmp[BUFFER_SIZE >> 1]; // 4
	
	noise_level = (((noise_level * 94) + (med * 6))/100);
	//UART_SendByte(noise_level);
}

char check_noise_value(void)
{
	uint8_t i;
	char outcome = 0;
		
	/* limit_range = 100 - 100/4 so limit_range equals 75% NOISE_INIT_VALUE */
	char limit_range = noise_level - (noise_level >> 2);
	
	UART_SendByte(limit_range);
	rssi_on();
	
	for(i=0;i<5;i++)
	{
		rssi_value = ad_poll();
		if(rssi_value>limit_range)
		{
			update_noise_value(rssi_value);
			outcome = 1;
			break;
		}
	}

	rssi_off();
	return outcome;
}

void b_mac_init (void)
{
	uint8_t i;	

	ad_init();
	head = 0;
	
	for(i=0; i<BUFFER_SIZE; i++) noise_Buffer[i] = NOISE_INIT_VALUE;	
	noise_level = NOISE_INIT_VALUE;
	
	rssi_on();
	for (i = 0; i < 100; i++) {
        rssi_value = ad_poll();
        if (rssi_value > noise_level) update_noise_value(rssi_value);  
	}
	rssi_off();
}
