#include "cc1000_spi.h"


void SPI_Init(void)
{
	/* init the pin direction */
   DDRB &= ~((1 << DDB0) | (1 << DDB1)); // SCK clock input
   SPCR &= ~((1 << CPOL) | (1 << CPHA)); // polarity and phase
   DDRB |= (1 << DDB3);                  // miso to output
   DDRB &= ~((1 << DDB0) | (1 << DDB2)); // mosi to input (SPI_Slave_Mode)
      
   cc1000_mode(CC1000_MODE_RX);

   //SPCR &= ~(1 << SPIE); 
   //SPCR |= (1 << SPE);

   SPCR = ((1 << SPE)|(1 << SPIE)); //enable SPI interrupt
   sei();							//TODO: spi_int should be activate later
}

char checksum(char data) { 	//calculate boolean checksum
  char ret=0; 				//not in loop to make the code faster
  if(data&0x01) ret=~ret;
  if(data&0x02) ret=~ret;
  if(data&0x04) ret=~ret;
  if(data&0x08) ret=~ret;
  if(data&0x10) ret=~ret;
  if(data&0x20) ret=~ret;
  if(data&0x40) ret=~ret;
  if(data&0x80) ret=~ret;
  return ret;
}

/***********************************************************************************/

void SPI_transmit(char data_t)
{	
	SPDR = data_t;
	/*wait for transmission complete*/
	while(!(SPSR & (1<<SPIF)));
}

char SPI_receive(void)
{	
	/*Wait for reception complete*/
	while(!(SPSR & (1<<SPIF)));
	data_r = SPDR;
	/*Return data register*/
	return data_r;
}
