#include "cc1000_Buffer.h"

 #define RXCIE_ RXCIE0
 #define RXEN_ RXEN0
 #define UCSR_B UCSR0B

/* settings for change */
#ifndef F_CPU
//#define F_CPU        8000000 
//#define F_CPU		   1843200
#define F_CPU		   7372800//Hz
#endif

//------------------------------------------------------------------------------
                      
#define BAUDRATE     9600   
                    
#define BITS         8	//number of bits to use; from 5 to 8

#define PARITY       0	// 0 - disable, 2 - even parity, 3 - odd parity

#define STOP_BITS    1	// 1 or 2    
               
/* ATmega128 settings - do not change !*/
#define UART_CPU			F_CPU

#define UBRR_reg (UART_CPU/(16L * BAUDRATE))-1
#define UCSRC_reg ((PARITY << 4) + ((STOP_BITS - 1) << 3) + ((BITS - 5) << 1))
//--------------------------------------------------------------------------------

#define TRUE     1 
#define FALSE    0 

void UART_SendByte(char data);
void UART_SendString(char *str);
void UART_SendBytes(char *str, int len);
void UART_SendInt(char i);

#define DEBUG_VAR(v)\
UART_SendString(#v);\
UART_SendString(" = ");\
UART_SendInt(v);\
UART_SendString("\r");

